Description

Hi,

In our environment we're pondering patching Foreman to make the automatic host creation when facts/reports are uploaded optional

based on a configuration parameter.

(models/hosts.rb; line 353)

347   def self.importHostAndFacts yaml

348     facts = YAML::load yaml

349     return false unless facts.is_a?(Puppet::Node::Facts)

350 

351     h = Host.find_by_certname facts.name

352     h ||= Host.find_by_name facts.name

353     h ||= Host.new :name => facts.name

[...]

 (models/report.rb; line 80)

 73   def self.import(yaml)

 74     report = YAML.load(yaml)

 75     raise "Invalid report" unless report.is_a?(Puppet::Transaction::Report)

 76     logger.info "processing report for #{report.host}" 

 77     begin

 78       host = Host.find_by_certname report.host

 79       host ||= Host.find_by_name report.host

 80       host ||= Host.new :name => report.host

[...]

 Foreman is not just a visualization/reporting tool for us, it's sort of a source of truth. Thus, we don't want hosts to be created

automatically on Foreman when they chat to the puppet masters. Basically, if the host is not in Foreman it does not exist for us.

The patch is quite simple, but we'd like to discuss what you think about the new feature before submitting a pull request.

Thanks

N

Related issues:

Related to Foreman - Feature #2752: Make automatic host creation switchable f... Duplicate 11/21/2012

Related to Foreman - Feature #3364: Add option to disable automatc host creat... Closed 10/18/2013

Associated revisions

Revision 554be427 - 07/05/2013 12:42 PM - Nacho Barrientos

fixes #1963 - prevent host creation when facts are uploaded via new setting
History

#1 - 06/28/2013 01:31 PM - Dominic Cleal

- Category set to Facts

- Status changed from New to Ready For Testing

- Target version set to 1.3.0

https://github.com/theforeman/foreman/pull/647

PR only covers the facts portion of this

#2 - 07/05/2013 01:17 PM - Nacho Barrientos

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 554be427b0d76708893b81676e7728e105045505.

#3 - 10/18/2013 03:36 PM - Dominic Cleal

- Related to Feature #3364: Add option to disable automatc host creation when a report is received added
